package frc.robot.subsystems;

import java.util.function.DoubleSupplier;

import com.revrobotics.CANSparkMax;
import com.revrobotics.CANSparkMaxLowLevel.MotorType;

import edu.wpi.first.wpilibj.Encoder;
import edu.wpi.first.wpilibj.drive.DifferentialDrive;
import edu.wpi.first.wpilibj.motorcontrol.MotorController;
import edu.wpi.first.wpilibj2.command.Command;
import edu.wpi.first.wpilibj2.command.SubsystemBase;
import frc.robot.constants.DrivetrainConstants;
public class Drivetrain extends SubsystemBase{
    private MotorController leftFront;
    private MotorController leftRear;
    private MotorController rightFront;
    private MotorController rightRear;

    private DifferentialDrive drive;;


    private Drivetrain() {
        leftFront = new CANSparkMax(DrivetrainConstants.kLeftFrontID, MotorType.kBrushless);
        rightFront = new CANSparkMax(DrivetrainConstants.kRightFrontID, MotorType.kBrushless);
        leftRear = new CANSparkMax(DrivetrainConstants.kLeftRearID, MotorType.kBrushless);
        rightRear = new CANSparkMax(DrivetrainConstants.kRightRearID, MotorType.kBrushless);

        ((CANSparkMax)leftRear).follow((CANSparkMax)leftFront);
        ((CANSparkMax)rightRear).follow((CANSparkMax)rightFront);

        rightFront.setInverted(true);
        
        drive = new DifferentialDrive(leftFront, rightFront);  
        Encoder Encoder = new Encoder(0,1);
    }
    public Command driveArcade(DoubleSupplier xSpeed, DoubleSupplier zRotation) {
        return run (() -> {
            drive.arcadeDrive(xSpeed.getAsDouble(), zRotation.getAsDouble());
        });
    }
    public Command driveTank(DoubleSupplier leftSpeed, DoubleSupplier rightSpeed) {
        return run(() -> {
            drive.tankDrive(leftSpeed.getAsDouble(), rightSpeed.getAsDouble());
        });
    }
}
