package frc.robot.subsystems;

import java.util.function.DoubleSupplier;

import com.ctre.phoenix.motorcontrol.can.WPI_VictorSPX;

import edu.wpi.first.wpilibj2.command.Command;
import edu.wpi.first.wpilibj2.command.SubsystemBase;
import frc.robot.constants.intakeConstants;

public class Intake extends SubsystemBase{
    private WPI_VictorSPX motor1;


    public Intake() {
        motor1 = new WPI_VictorSPX(intakeConstants.K1MotorPWM);
    
    }
    public Command setSpeed(DoubleSupplier speed) {
        //sets the motors speed
        return run(() -> {
            motor1.set(speed.getAsDouble());
        });    
    }
    public Command stop() {
        //stops the motors
        return setSpeed(() -> 0);
    }
} 

